﻿init python:
    from copy import copy
    class leveling:
        def __init__(self, level, type):
            self.level = 0
            self.exp = 0
            self.talents = 0
            self.used_talents = 0
            self.type = type
            self.level_up(level)

        def got_exp(self, exp):
            self.exp += exp
            if self.exp > 99:
                self.exp -= 100
                self.level_up(1)

        def level_up(self, levels):
            for i in range(levels):
                self.level += 1
                self.talents += 10

    class stats:
        def __init__(self):
            self.health = 100
            self.mana = 40
            self.stamina = 100

            self.max_health = 100
            self.max_mana = 40
            self.max_stamina = 100

            self.strength = 5
            self.agility = 2

            self.is_alive = True

    class fighter_animation:
        def __init__(self, base):
            self.base = base
            self.animation = "idle"
            self.variation = None


    class enemy(leveling, stats, fighter_animation):
        def __init__(self, name, base, level = 1, type = "Peasant"):
            stats.__init__(self)
            leveling.__init__(self, level, type)
            fighter_animation.__init__(self, base)
            self.name = name
            self.action = None
            self.is_ai = True

    class player(leveling, stats):
        def __init__(self, name, level = 1, type = "Peasant"):
            stats.__init__(self)
            leveling.__init__(self, level, type)
            self.name = name
            self.is_ai = False

    class battle_class:
        def __init__(self, players, enemies):
            self.players = players
            self.enemies = enemies

            self.stat = "playing"
            self.active = self.players[0]
            self.active_index = 0
            self.winner = False

        def next(self):
            self.stat = None
            all = self.players + self.enemies
            max = len(all) -1

            self.active_index += 1
            if self.active_index > max:
                self.active_index = 0
            self.active = all[self.active_index]
            
            if self.active.is_alive:
                return
            self.winner = check_for_wins()
            if not self.winner:
                self.next()
        def check_for_wins(self):
            enemies_alive = [i for i in self.enemies if i.is_alive]
            players_alive = [i for i in self.players if i.is_alive]
            if not len(enemies_alive):
                return "You win"
            if not len(enemies_alive):
                return "You lose"
            return False

        def attack(self):
            self.stat = "choose enemy"
        def attack_enemy(self, enemy):
            enemy.health -= self.active.strength
            self.stat = "waiting"

        def spell(self):
            pass
        def rest(self):
            pass
        def escape(self):
            pass
        def ai(self):
            chance = random.randint(0,100)
            targets = [i for i in self.players if i.is_alive]
            target = random.choice(targets)
            if chance < 75:
                renpy.notify("attack")
                target.health -= self.active.strength
            else:
                renpy.notify("spell")
                target.health -= self.active.strength
            self.next()
            
screen battle():
    modal True
    style_prefix "battle"
    default g = battle_class(
        players = [
            player("Me", 1)
        ],
        enemies = [
            enemy("Enemy", "enemy_1", 1),
            enemy("Enemy", "enemy_2", 1),
            enemy("Enemy", "enemy_3", 1),
            enemy("Enemy", "enemy_4", 1),
        ]
        )
    default positions = [
        (-100, 40),
        (100, 40),
        (-300, 0),
        (300, 0),
    ]


    # Enemies
    for p,i in zip(positions, g.enemies):
        fixed fit_first True:
            align .5,.5 offset p
            add i.base:
                align .5,.5
                if i.animation == "idle":
                    at battle_idle
            if i == g.active:
                at battle_zoom(4)
            else:
                at battle_zoom(3)

    for p,i in zip(positions, g.enemies):
        fixed fit_first True:
            align .5,.8 offset p
            use battle_stats(enemy = i)
            if i == g.active:
                add "battle_arrow" align .5,.0 yoffset -96

    # GUI
    frame:
        yfill True xsize 450 xalign .0
        background "#000"
    frame:
        yfill True xsize 450 xalign 1.0
        background "#000"
    frame:
        xysize 1056,1152
        background Frame("frame_mask", 64, 130)

    hbox:
        spacing 48 align .5,.5
        vbox:
            spacing 48
            frame:
                xysize 384,528
            frame:
                xysize 384,384
        null width 960
        vbox:
            spacing 48
            frame:
                xysize 384,384
                hbox:
                    align .5,.5
                    for i in g.players:
                        vbox:
                            align .5,.5
                            # add i.base  align .5,.5 at zoom(3, True)
                            use battle_stats(enemy = i, x_size = 350, is_player = True)
            frame:
                xysize 384,528
                if g.active.is_ai:
                    timer 1 repeat True action Function(g.ai)
                    vbox:
                        align .5,.5 spacing 10
                        text "Enemies turn."
                elif g.stat == "choose enemy":
                    vbox:
                        align .5,.5 spacing 10
                        for n,i in enumerate(g.enemies):
                            button:
                                add i.base
                                action Function(g.attack_enemy, i)  keysym "{}".format(n+1)
                elif g.stat == "waiting":
                    timer 1 repeat True action Function(g.next)

                else:
                    vbox:
                        align .5,.5 spacing 10
                        text "Choose your move."

                        button:
                            text "Attack"
                            action Function(g.attack) keysym "1"
                        button:
                            text "Spell"
                            action Function(g.spell) keysym "2"
                        button:
                            text "Items"
                            action Function(g.rest) keysym "3"
                        button:
                            text "Escape"
                            action Function(g.escape) keysym "4"


screen battle_stats(enemy, x_size = 160, is_player = False):
    vbox:
        align .5,.5 spacing 8
        text "Level: {}".format(enemy.level)
        text enemy.name
        bar value enemy.health range enemy.max_health xysize (x_size,20) left_bar Frame("bar_health", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.mana range enemy.max_mana xysize (x_size,20) left_bar Frame("bar_mana", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.stamina range enemy.max_stamina xysize (x_size,20) left_bar Frame("bar_stamina", 20, 10) right_bar Frame("bar_empty", 20, 10)
        if is_player:
            bar value enemy.exp range 1000 xysize (x_size,20) left_bar Frame("bar_exp", 20, 10) right_bar Frame("bar_empty", 20, 10)

transform battle_zoom(z):
    nearest True
    ease .2 zoom z
transform battle_idle():
    nearest True subpixel True
    anchor (.5,1.0)
    parallel:
        ease .6 yzoom .9
        ease .6 yzoom 1.0
        repeat
    parallel:
        ease .8 xzoom 1.0
        ease .4 xzoom .9
        repeat

style battle_text:
    align (.5,.5)
style battle_button:
    align (.5,.5) padding (20,20)
    background Frame("frame_filled", 30,30)
style battle_frame:
    align (.5,.5) padding (20,20)
    background Frame("frame_filled", 30,30)

init:
    image frame_filled:
        Crop((0,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image frame_empty:
        Crop((32,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image battle_arrow:
        Crop((96,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image frame_mask:
        Crop((0,32,64,96), "battle/gui.png")
        zoom 3 nearest True

    image bar_health = Crop((64,32,32,16), "battle/gui.png")
    image bar_mana = Crop((64,48,32,16), "battle/gui.png")
    image bar_stamina = Crop((96,32,32,16), "battle/gui.png")
    image bar_exp = Crop((86,48,32,16), "battle/gui.png")
    image bar_empty = Crop((64,64,32,16), "battle/gui.png")

init:
    image enemy_1 = Crop((0,0,64,64), "battle/sprites.png")
    image enemy_2 = Crop((64,0,64,64), "battle/sprites.png")
    image enemy_3 = Crop((128,0,64,64), "battle/sprites.png")
    image enemy_4 = Crop((192,0,64,64), "battle/sprites.png")

    image enemy_5 = Crop((0,64,64,64), "battle/sprites.png")
    image enemy_6 = Crop((64,64,64,64), "battle/sprites.png")
    image enemy_7 = Crop((128,64,64,64), "battle/sprites.png")
    image enemy_8 = Crop((192,64,64,64), "battle/sprites.png")

    image enemy_9 = Crop((0,128,64,64), "battle/sprites.png")
    image enemy_10 = Crop((64,128,64,64), "battle/sprites.png")
    image enemy_11 = Crop((128,128,64,64), "battle/sprites.png")
    image enemy_12 = Crop((192,128,64,64), "battle/sprites.png")

    image enemy_13 = Crop((0,192,64,64), "battle/sprites.png")
    image enemy_14 = Crop((64,192,64,64), "battle/sprites.png")
    image enemy_15 = Crop((128,192,64,64), "battle/sprites.png")
    image enemy_16 = Crop((192,192,64,64), "battle/sprites.png")



label battle_example:
    show bg jungle with dissolve
    call screen battle()


